#include <QDateTime>
#include <QFile>
#include <QMessageBox>
#include <QTextStream>

#include "Dictate1.h"

extern Player g_voice; // Only to be able to stop the sound

Dictate1::Dictate1(QWidget *parent) : CenterFrame(parent) {
   lo=new QVBoxLayout;
   loButtons=new QHBoxLayout;
   bHasTimedOut=false;

   line1=new QHBoxLayout;
   line2=new QHBoxLayout;
   line3=new QHBoxLayout;
   line4=new QHBoxLayout;
   line5=new QHBoxLayout;
   line6=new QHBoxLayout;
   line7=new QHBoxLayout;
   line8=new QHBoxLayout;
   line9=new QHBoxLayout;
   line10=new QHBoxLayout;
   line11=new QHBoxLayout;

   laHeadLine=new QLabel(tr("<html><b>Diktat 1</b><br>"));
   laHeadLine->setFont(foHeadLine);

   laTime=new QLabel(tr("<b>Du har 10 minutter til diktaten</b><hr></html>"));
   laTime->setFont(foTime);

   // Line 1:
   la1=new QLabel(tr("Vi"));
   dw1=new DictateWord(this,tr("kørte"),tr("1.wav"),true);
   la2=new QLabel(tr("til byen fredag morgen. Der var"));
   dw2=new DictateWord(this,tr("fint"),tr("2.wav"),true);
   line1->addWidget(la1);
   line1->addWidget(dw1);
   line1->addWidget(la2);
   line1->addWidget(dw2);
   line1->addStretch();

   // Line 2:
   la3=new QLabel(tr("vejr, og"));
   dw3=new DictateWord(this,tr("solen"),tr("3.wav"),true);
   la4=new QLabel(tr("skinnede. Vi havde"));
   dw4=new DictateWord(this,tr("talt"),tr("4.wav"),true);
   la5=new QLabel(tr("om, at vi"));
   line2->addWidget(la3);
   line2->addWidget(dw3);
   line2->addWidget(la4);
   line2->addWidget(dw4);
   line2->addWidget(la5);
   line2->addStretch();

   // Line 3:
   la6=new QLabel(tr("ville se det"));
   dw5=new DictateWord(this,tr("gamle"),tr("5.wav"),true);
   la7=new QLabel(tr("apotek. Vi havde"));
   dw6=new DictateWord(this,tr("læst"),tr("6.wav"),true);
   la8=new QLabel(tr(", at der er"));
   line3->addWidget(la6);
   line3->addWidget(dw5);
   line3->addWidget(la7);
   line3->addWidget(dw6);
   line3->addWidget(la8);
   line3->addStretch();

   // Line 4:
   dw7=new DictateWord(this,tr("hele"),tr("7.wav"),true);
   la9=new QLabel(tr("femten figurer af svaner inde på apoteket."));
   line4->addWidget(dw7);
   line4->addWidget(la9);
   line4->addStretch();

   // Line 5:
   la10=new QLabel(tr("Vi ville"));
   dw8=new DictateWord(this,tr("prøve"),tr("8.wav"),true);
   la11=new QLabel(tr("at finde svanerne. Der er"));
   dw9=new DictateWord(this,tr("fire"),tr("9.wav"),true);
   la12=new QLabel(tr("uden"));
   line5->addWidget(la10);
   line5->addWidget(dw8);
   line5->addWidget(la11);
   line5->addWidget(dw9);
   line5->addWidget(la12);
   line5->addStretch();

   // Line 6:
   la13=new QLabel(tr("på apoteket. Der er to på"));
   dw10=new DictateWord(this,tr("døren"),tr("10.wav"),true);
   la14=new QLabel(tr("Der er tre i"));
   dw11=new DictateWord(this,tr("glas"),tr("11.wav"),true);
   la15=new QLabel(tr(","));
   line6->addWidget(la13);
   line6->addWidget(dw10);
   line6->addWidget(la14);
   line6->addWidget(dw11);
   line6->addWidget(la15);
   line6->addStretch();

   // Line 7:
   la16=new QLabel(tr("og der er"));
   dw12=new DictateWord(this,tr("lavet"),tr("12.wav"),true);
   la17=new QLabel(tr("svaner i ryggen på fem"));
   dw13=new DictateWord(this,tr("stole"),tr("13.wav"),true);
   la18=new QLabel(tr(". En"));
   line7->addWidget(la16);
   line7->addWidget(dw12);
   line7->addWidget(la17);
   line7->addWidget(dw13);
   line7->addWidget(la18);
   line7->addStretch();

   // Line 8:
   dw14=new DictateWord(this,tr("stor"),tr("14.wav"),true);
   la19=new QLabel(tr("svane i porcelæn fungerer som en"));
   dw15=new DictateWord(this,tr("hane"),tr("15.wav"),true);
   la20=new QLabel(tr(","));
   line8->addWidget(dw14);
   line8->addWidget(la19);
   line8->addWidget(dw15);
   line8->addWidget(la20);
   line8->addStretch();

   // Line 9:
   la21=new QLabel(tr("som man kan få"));
   dw16=new DictateWord(this,tr("gåsevin"),tr("16.wav"),true);
   la22=new QLabel(tr("fra."));
   line9->addWidget(la21);
   line9->addWidget(dw16);
   line9->addWidget(la22);
   line9->addStretch();

   // Line 10:
   la23=new QLabel(tr("Svanen er et"));
   dw17=new DictateWord(this,tr("symbol"),tr("17.wav"),true);
   la24=new QLabel(tr("for apoteker, ligesom"));
   dw18=new DictateWord(this,tr("løven"),tr("18.wav"),true);
   la25=new QLabel(tr("er"));
   line10->addWidget(la23);
   line10->addWidget(dw17);
   line10->addWidget(la24);
   line10->addWidget(dw18);
   line10->addWidget(la25);
   line10->addStretch();

   // Line 11:
   la26=new QLabel(tr("det. Svanen står for det"));
   dw19=new DictateWord(this,tr("fine"),tr("19.wav"),true);
   la27=new QLabel(tr("og"));
   dw20=new DictateWord(this,tr("rene"),tr("20.wav"),true);
   la28=new QLabel(tr("."));
   line11->addWidget(la26);
   line11->addWidget(dw19);
   line11->addWidget(la27);
   line11->addWidget(dw20);
   line11->addWidget(la28);
   line11->addStretch();

   laLine1=new QLabel(tr("<html><hr></html>"));
   laClickArrow=new QLabel(tr("Når du mener, du er færdig, klikker du på den grønne pil."));
   laLine2=new QLabel(tr("<html><hr></html>"));

   dbNext=new DarkButton(this,tr("next.png"));
   loButtons->addStretch();
   loButtons->addWidget(dbNext);

   lo->addSpacing(20);
   lo->addWidget(laHeadLine);
   lo->addWidget(laTime);
   lo->addSpacing(20);
   lo->addLayout(line1);
   lo->addLayout(line2);
   lo->addLayout(line3);
   lo->addLayout(line4);
   lo->addSpacing(20);
   lo->addLayout(line5);
   lo->addLayout(line6);
   lo->addLayout(line7);
   lo->addLayout(line8);
   lo->addLayout(line9);
   lo->addSpacing(20);
   lo->addLayout(line10);
   lo->addLayout(line11);
   lo->addSpacing(20);
   lo->addWidget(laLine1);
   lo->addWidget(laClickArrow);
   lo->addWidget(laLine2);
   lo->addLayout(loButtons);
   lo->addStretch();
   setLayout(lo);

   // Handle returns:
   connect(dw1,SIGNAL(returnPressed()),dw2,SLOT(setFocus()));
   connect(dw2,SIGNAL(returnPressed()),dw3,SLOT(setFocus()));
   connect(dw3,SIGNAL(returnPressed()),dw4,SLOT(setFocus()));
   connect(dw4,SIGNAL(returnPressed()),dw5,SLOT(setFocus()));
   connect(dw5,SIGNAL(returnPressed()),dw6,SLOT(setFocus()));
   connect(dw6,SIGNAL(returnPressed()),dw7,SLOT(setFocus()));
   connect(dw7,SIGNAL(returnPressed()),dw8,SLOT(setFocus()));
   connect(dw8,SIGNAL(returnPressed()),dw9,SLOT(setFocus()));
   connect(dw9,SIGNAL(returnPressed()),dw10,SLOT(setFocus()));
   connect(dw10,SIGNAL(returnPressed()),dw11,SLOT(setFocus()));
   connect(dw11,SIGNAL(returnPressed()),dw12,SLOT(setFocus()));
   connect(dw12,SIGNAL(returnPressed()),dw13,SLOT(setFocus()));
   connect(dw13,SIGNAL(returnPressed()),dw14,SLOT(setFocus()));
   connect(dw14,SIGNAL(returnPressed()),dw15,SLOT(setFocus()));
   connect(dw15,SIGNAL(returnPressed()),dw16,SLOT(setFocus()));
   connect(dw16,SIGNAL(returnPressed()),dw17,SLOT(setFocus()));
   connect(dw17,SIGNAL(returnPressed()),dw18,SLOT(setFocus()));
   connect(dw18,SIGNAL(returnPressed()),dw19,SLOT(setFocus()));
   connect(dw19,SIGNAL(returnPressed()),dw20,SLOT(setFocus()));
   connect(dw20,SIGNAL(returnPressed()),dw1,SLOT(setFocus()));

   connect(dbNext,SIGNAL(clicked()),this,SLOT(slotNextPage()));
}

void Dictate1::saveInfo() {
   int nNNType0=0,nEndTime,nDuration,nHours,nMinuts,nSeconds;

   // Fetch time of ending the dictate:
   QDateTime dt;
   QTime time=dt.currentDateTime().time();
   nEndTime=3600*time.hour() + 60*time.minute() + time.second();
   nDuration=nEndTime-nBeginTime;
   nHours=nDuration/3600; // Not used for printout
   nDuration-=nHours*3600;
   nMinuts=nDuration/60;
   nDuration-=nMinuts*60;
   nSeconds=nDuration;

   QString sMinuts,sSeconds;
   QChar c('0');
   sMinuts=QString("%1").arg(nMinuts,2,10,c);
   sSeconds=QString("%1").arg(nSeconds,2,10,c);

   QFile file("results.html");
   if (!file.open(QIODevice::Append)) {
      QMessageBox::critical(this,tr("Kritisk fejl!"),tr("Programmet kan ikke skrive til\nfilen \"results.html\".\n\nKontakt din lærer!"),QMessageBox::Ok);
      exit(1);
   }
   QTextStream stream(&file);
   stream.setCodec("UTF-8");
   stream << "<h3>Diktat 1 [" << sMinuts << ":" << sSeconds << "]</h3>\n\n";
   stream << "<p>\n<small>\n";
   stream << dw1->showAnswer(nNNType0) << tr(", ") << dw2->showAnswer(nNNType0) << tr(", ") << dw3->showAnswer(nNNType0) << tr(", ") << dw4->showAnswer(nNNType0) << tr(", ") << dw5->showAnswer(nNNType0) << tr(", ");
   stream << dw6->showAnswer(nNNType0) << tr(", ") << dw7->showAnswer(nNNType0) << tr(", ") << dw8->showAnswer(nNNType0) << tr(", ") << dw9->showAnswer(nNNType0) << tr(", ") << dw10->showAnswer(nNNType0) << tr(", ");
   stream << dw11->showAnswer(nNNType0) << tr(", ") << dw12->showAnswer(nNNType0) << tr(", ") << dw13->showAnswer(nNNType0) << tr(", ") << dw14->showAnswer(nNNType0) << tr(", ") << dw15->showAnswer(nNNType0) << tr(", ");
   stream << dw16->showAnswer(nNNType0) << tr(", ") << dw17->showAnswer(nNNType0) << tr(", ") << dw18->showAnswer(nNNType0) << tr(", ") << dw19->showAnswer(nNNType0) << tr(", ") << dw20->showAnswer(nNNType0) << tr(".");
   stream << "\n</small>\n\n<p>\n<small>\n<font color=\"blue\"><b>Total: " << nNNType0 << "</b></font>";

   if (nNNType0>=18) {
      stream << "\n</small>\n\n";
      bPassed=true;
   }
   else {
      stream << "<br>\nTrin 1\n</small>\n\n</body>\n</html>\n"; // Since the student didn't pass this will be the end of the file
      bPassed=false;
   }

   stream.flush();
   file.close();
}

void Dictate1::slotNextPage() {
   g_voice.stopSound();
   if (!bHasTimedOut) {
      QMessageBox mb; // Danish yes/no question:
      QAbstractButton *noButton;
      mb.setWindowTitle(tr("Advarsel!"));
      mb.setIcon(QMessageBox::Warning);
      mb.setText(tr("Er du sikker på, at du er\nHELT færdig med Diktat 1?"));
      mb.addButton(tr("Ja"),QMessageBox::YesRole);
      noButton=mb.addButton(tr("Nej"),QMessageBox::NoRole);
      mb.exec();
      if (mb.clickedButton()==noButton) return;
   }
   saveInfo();
   emit nextPage(); // Send next-page-button clicked signal, grabbed by MainWindow.
}

void Dictate1::showEvent(QShowEvent* e) { // Set the initial focus to the first word
   activateWindow();
   dw1->setFocus();

   // Fetch time of beginning the dictate:
   QDateTime dt;
   QTime time=dt.currentDateTime().time();
   nBeginTime=3600*time.hour() + 60*time.minute() + time.second();

   QWidget::showEvent(e);
}

bool Dictate1::isPassed() {
   return bPassed;
}

void Dictate1::makeGrey() {
   dw1->setEnabled(false);
   dw2->setEnabled(false);
   dw3->setEnabled(false);
   dw4->setEnabled(false);
   dw5->setEnabled(false);
   dw6->setEnabled(false);
   dw7->setEnabled(false);
   dw8->setEnabled(false);
   dw9->setEnabled(false);
   dw10->setEnabled(false);
   dw11->setEnabled(false);
   dw12->setEnabled(false);
   dw13->setEnabled(false);
   dw14->setEnabled(false);
   dw15->setEnabled(false);
   dw16->setEnabled(false);
   dw17->setEnabled(false);
   dw18->setEnabled(false);
   dw19->setEnabled(false);
   dw20->setEnabled(false);
   bHasTimedOut=true; // So that we don't ask if the student really is sure he has finised
}
