#include <QFileDialog>
#include <QPrintDialog>
#include <QPrinter>

#include "Results.h"

Results::Results(QWidget *parent) : CenterFrame(parent) {
   lo=new QVBoxLayout;
   loButtons=new QHBoxLayout;

   laHeadLine=new QLabel(tr("<html><b>Resultater</b></html>"));
   laHeadLine->setFont(foHeadLine);

   tb=new QTextBrowser;
   tb->setFrameShape(QFrame::NoFrame);

   dbSaveAsPDF=new DarkButton(this,tr("pdf.png"));
   laPDF=new QLabel(tr("<html>Gem som<br>PDF-fil</html>"));
   laPrint=new QLabel(tr("Udskriv"));
   dbPrintResults=new DarkButton(this,tr("print.png"));

   loButtons->addWidget(dbSaveAsPDF);
   loButtons->addWidget(laPDF);
   loButtons->addStretch();
   loButtons->addWidget(laPrint);
   loButtons->addWidget(dbPrintResults);

   lo->addSpacing(20);
   lo->addWidget(laHeadLine);
   lo->addSpacing(20);
   lo->addWidget(tb);
   lo->addLayout(loButtons);
   setLayout(lo);

   connect(dbSaveAsPDF,SIGNAL(clicked()),this,SLOT(saveAsPDF()));
   connect(dbPrintResults,SIGNAL(clicked()),this,SLOT(printResults()));
}

void Results::loadResults() {
   tb->setSource(tr("results.html"));
   tb->setFocus();
}

void Results::saveAsPDF() {
   QPrinter printer;
   QString sFileName=QFileDialog::getSaveFileName(this,tr("Gem resultater som PDF-fil"),"",tr("Adobe PDF-filer (*.pdf)"));
   if (sFileName.isEmpty()) return;
   printer.setOutputFileName(sFileName);
   printer.setOutputFormat(QPrinter::PdfFormat);
//   printer.setFullPage(true);
   tb->print(&printer);
}

void Results::printResults() {
   QPrinter printer;
   QPrintDialog *dialog=new QPrintDialog(&printer,this);
   dialog->setWindowTitle("Udskriv resultater");
   if (dialog->exec()==QDialog::Accepted) tb->print(&printer);
}
