#include "SplashDialog.h"

SplashDialog::SplashDialog(QWidget *parent) : QDialog(parent) {
   setWindowIcon(QIcon(tr(":/images/diktrin64.png")));
   setWindowTitle(tr("Adgang til..."));

   lo=new QVBoxLayout;
   loButtons=new QHBoxLayout;

   QPixmap piLogo(":/images/diktrin-splash.png");
   laLogo=new QLabel(this);
   laLogo->setPixmap(piLogo);
   laLogo->setAlignment(Qt::AlignRight);

   foHeadLine=font();
   foHeadLine.setPointSize(16);
   foSmall=font();
   foSmall.setPointSize(7);

   laHeadLine=new QLabel(tr("<html><hr>Diktrin</html>"));
   laHeadLine->setFont(foHeadLine);

   laVersion=new QLabel(tr("<html><b>v e r s i o n&nbsp;&nbsp;&nbsp;1 . 0 2</b></html>"));
   laVersion->setFont(foSmall);

   laAuthors=new QLabel(tr("<html>Copyright © 2010 Monica Irene Krarup Olesen (idé)<br>og Søren Krarup Olesen (programmering).<p>Tak til »stemmen« Pia Friis.<hr></html>"));
   laAuthors->setFont(foSmall);

   la1=new QLabel(tr("<html>Velkommen til »Diktrin« - en diktat<br>til trinindplacering.</html>"));
   la2=new QLabel(tr("Indtast password:"));
   lePassword=new QLineEdit;
   lePassword->setEchoMode(QLineEdit::Password);
   laAccept=new QLabel(tr(" "));

   pbCancel=new QPushButton(tr("Annullér"),this);
   pbOK=new QPushButton(tr("Fortsæt"),this);
   pbOK->setDefault(true);
   loButtons->addWidget(pbCancel);
   loButtons->addStretch();
   loButtons->addWidget(pbOK);

   lo->addWidget(laLogo);
   lo->addWidget(laHeadLine);
   lo->addWidget(laVersion);
   lo->addSpacing(20);
   lo->addWidget(laAuthors);
   lo->addSpacing(10);
   lo->addWidget(la1);
   lo->addSpacing(10);
   lo->addWidget(la2);
   lo->addWidget(lePassword),
   lo->addWidget(laAccept);
   lo->addStretch();
   lo->addLayout(loButtons);
   setLayout(lo);

   connect(pbCancel,SIGNAL(clicked()),this,SLOT(reject()));
   connect(pbOK,SIGNAL(clicked()),this,SLOT(slotCheckPassword()));

   lePassword->setFocus();
}

void SplashDialog::slotCheckPassword() {
   if (lePassword->text()==tr("leverpostej")) accept();
   else {
      laAccept->setText(tr("<html><font color=\"red\">Forkert password!</font></html>"));
      lePassword->setFocus();
   }
}
