#include "MainWindow.h"

extern Dictate1 *dictate1;
extern Dictate2 *dictate2;

TimeLimiter::TimeLimiter(QWidget *parent) : QWidget(parent) {
   timer=new QTimer;

   foNormal=font();
   foNormal.setPointSize(8);
   setFont(foNormal);

   layout=new QVBoxLayout;

   la=new QLabel;
   pb=new QProgressBar;
   pb->setMaximumHeight(12);
   pb->setTextVisible(false);

   layout->addWidget(la);
   layout->addWidget(pb);

   setLayout(layout);
   hide(); // Hide to begin with

   connect(timer,SIGNAL(timeout()),this,SLOT(slotShowMinutsLeft()));
}

void TimeLimiter::slotShowMinutsLeft() {
   QString s,sMinsLeft;
   sMinsLeft.setNum(nMinsLeft);
   if (nMinsLeft>1) s=tr("Du har ") + sMinsLeft + tr(" minutter tilbage");
   else if (nMinsLeft==1) s=tr("<html>Du har <b>kun</b> ") + sMinsLeft + tr(" minut tilbage</html>");
   else s=tr("Tiden er udløbet!");
   la->setText(s);
   pb->setValue(nMinsLeft);
   if (nMinsLeft>0) nMinsLeft--;
   else { // Signals a timeOut() when nMinsLeft equals zero
      timer->stop();
      if (nDictate==1) dictate1->makeGrey();
      else dictate2->makeGrey();
      emit timeOut();
   }
}

void TimeLimiter::start(int nNNMinuts,int _nDictate) {
   nTimeOut=nNNMinuts;
   nMinsLeft=nNNMinuts;
   nDictate=_nDictate;
   pb->setRange(0,nNNMinuts);
   slotShowMinutsLeft();
   timer->setInterval(60000); // 60000 ms = 1 minut
   timer->start();
   show();
}

void TimeLimiter::stop() {
   timer->stop();
   hide();
}
